/*****************************************************************************
 * Une horloge synchonisée Wi-Fi avec un affichage style dés à jouer sur une
 * matrice à pixels W2812 de 64 leds en 8 colonnes de 8 ! le tout piloté
 * par un ESP32 pour donner quelques couleurs au temps qui passe 
 ***************************************************************************/

#include <WiFi.h> // Accès Wi-Fi
#include "time.h"  // Gestion du temps
#include <Adafruit_NeoPixel.h> // Pilotage des barres de led W_2812-8*8

#define DATA      4  //Sortie de commande du panneau de pixels 
#define NUMPIXELS 64 //Declaration du nombre de pixels

int Green, Red, Blue; //Variables des couleurs
int dice = 0; // Dé 1...4 pour les affichage "dizaine heure" "unité heure" etc ...
int tDigit;  // pixels a allumer pour former les chiffres 
int DH,UH,DM,UM;
int light = 3;  //Multiplicateur de luminosité

byte HR; // valeurs après extraction depuis le Wifi
byte MN;

const char* ssid       = "zzzzzzzzzzzz"; // Id de la box
const char* password   = "xxxxxxxxxxxxxxxxxxxx"; // Mot de passe Box

const char* ntpServer = "pool.ntp.org";
const long  gmtOffset_sec = 3600;
const int   daylightOffset_sec = 3600;

Adafruit_NeoPixel pixels(NUMPIXELS, DATA, NEO_GRB + NEO_KHZ800); // Format des données envoyées au panneau de led



void printLocalTime()
{
  struct tm timeinfo;
  if(!getLocalTime(&timeinfo)){
    return;
  }
   //Affectation en variable numérique de l'extraction aux heures, minutes
  HR = timeinfo.tm_hour;
  MN = timeinfo.tm_min;
  }


   
void setPixel (){
  // Fabrication d'un dé en fonction des pixels et du chiffre à afficher
switch (tDigit) {
  case 1:
    pixels.setPixelColor((9 + dice), pixels.Color(Green,Red,Blue));
    break;
  case 2:
   pixels.setPixelColor((2 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((16 + dice), pixels.Color(Green,Red,Blue));
    break;
 case 3:
   pixels.setPixelColor((2 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((16 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((9 + dice), pixels.Color(Green,Red,Blue));
    break;
 case 4:
   pixels.setPixelColor((2 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((0 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((18 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((16 + dice), pixels.Color(Green,Red,Blue));
    break;
 case 5:
   pixels.setPixelColor((9 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((2 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((0 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((18 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((16 + dice), pixels.Color(Green,Red,Blue));
    break;
 case 6:
   pixels.setPixelColor((1 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((17 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((2 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((0 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((18 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((16 + dice), pixels.Color(Green,Red,Blue));
    break;
 case 7:
   pixels.setPixelColor((1 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((17 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((2 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((0 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((18 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((16 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((9 + dice), pixels.Color(Green,Red,Blue));
    break;
 case 8:
   pixels.setPixelColor((1 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((17 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((2 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((0 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((18 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((16 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((8 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((10 + dice), pixels.Color(Green,Red,Blue));
    break;
 case 9:
   pixels.setPixelColor((1 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((17 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((2 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((0 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((18 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((16 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((10 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((9 + dice), pixels.Color(Green,Red,Blue));
   pixels.setPixelColor((8 + dice), pixels.Color(Green,Red,Blue));
    break;
  }

}



void setup() {
pixels.begin(); // Initialisation de la bibliothèque NeoPixel

//connection au WiFi
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
      delay(500);
  }
  
  //initialisation et emule le temps
  configTime(gmtOffset_sec, daylightOffset_sec, ntpServer);
  printLocalTime();

  //deconnection WiFi car le temps est trop long
  WiFi.disconnect(true);
  WiFi.mode(WIFI_OFF);

}

void loop() {

printLocalTime();

//Calcul de séparation des unités et dizaines   
DH = HR / 10;
UH = HR - (DH * 10);

DM = MN / 10;
UM = MN - (DM * 10);

//Limitation de la surbrillance 
if ((UH > 5) or (UM > 5) or ((DM + DH) > 5)) {
  light = 2;
}
else {
  light = 5;
}

Green = UH * light;
Red = UM * light;
Blue = (DM + DH)* light;

pixels.clear();

// Affectation des valeurs des dizaine, unité d'heure et minute pour créer les dés 
for ( int i = 1; i<=4;i++ ){  
      if (i = 1){
        dice = 0;
        tDigit = DM;
        setPixel (); 
      }
      if (i = 2){
        dice = 5;
        tDigit = DH;
        setPixel ();  
      }
      if (i = 3){
        dice = 40;
        tDigit = UM;
        setPixel ();  
      }
      if (i = 4){
        dice = 45;
        tDigit = UH;
       // i= 0;
        setPixel (); 
      }            
      delay(10);
}

//Clignoteur des secondes 
pixels.setPixelColor(27, pixels.Color(25,0,25));
pixels.setPixelColor(36, pixels.Color(25,0,25));
pixels.show();
delay (1000);

pixels.setPixelColor(27, pixels.Color(0,0,0));
pixels.setPixelColor(36, pixels.Color(0,0,0));
pixels.show();
delay (1000);

}
